Imports System
Imports System.Data.Entity.Migrations

Namespace Migrations
    Public Partial Class initial
        Inherits DbMigration
    
        Public Overrides Sub Up()
            CreateTable(
                "dbo.Alunoes",
                Function(c) New With
                    {
                        .AlunoID = c.Int(nullable := False, identity := True),
                        .Sobrenome = c.String(nullable := False, maxLength := 40),
                        .Nome = c.String(nullable := False, maxLength := 20),
                        .Ano = c.Int(nullable := False)
                    }) _
                .PrimaryKey(Function(t) t.AlunoID)
            
            CreateTable(
                "dbo.Matriculas",
                Function(c) New With
                    {
                        .MatriculaID = c.Int(nullable := False, identity := True),
                        .CursoID = c.Int(nullable := False),
                        .AlunoID = c.Int(nullable := False),
                        .Grau = c.Decimal(precision := 18, scale := 2)
                    }) _
                .PrimaryKey(Function(t) t.MatriculaID) _
                .ForeignKey("dbo.Cursoes", Function(t) t.CursoID, cascadeDelete := True) _
                .ForeignKey("dbo.Alunoes", Function(t) t.AlunoID, cascadeDelete := True) _
                .Index(Function(t) t.CursoID) _
                .Index(Function(t) t.AlunoID)
            
            CreateTable(
                "dbo.Cursoes",
                Function(c) New With
                    {
                        .CursoID = c.Int(nullable := False, identity := True),
                        .Titulo = c.String(),
                        .Creditos = c.Int(nullable := False)
                    }) _
                .PrimaryKey(Function(t) t.CursoID)
            
        End Sub
        
        Public Overrides Sub Down()
            DropIndex("dbo.Matriculas", New String() { "AlunoID" })
            DropIndex("dbo.Matriculas", New String() { "CursoID" })
            DropForeignKey("dbo.Matriculas", "AlunoID", "dbo.Alunoes")
            DropForeignKey("dbo.Matriculas", "CursoID", "dbo.Cursoes")
            DropTable("dbo.Cursoes")
            DropTable("dbo.Matriculas")
            DropTable("dbo.Alunoes")
        End Sub
    End Class
End Namespace
