Imports System
Imports System.Data.Entity
Imports System.Data.Entity.Migrations
Imports System.Linq
Imports Escola_Macoratti.Macoratti.Models

Namespace Migrations

    Friend NotInheritable Class Configuration
        Inherits DbMigrationsConfiguration(Of Macoratti.Models.EscolaContext)

        Public Sub New()
            AutomaticMigrationsEnabled = False
        End Sub

        Protected Overrides Sub Seed(context As Macoratti.Models.EscolaContext)
            context.Alunos.AddOrUpdate(New Aluno() With {.Nome = "Jefferson", .Sobrenome = "Andre Bueno", .Ano = AnoAcademico.Segundanista _
                                     }, New Aluno() With {.Nome = "Janice", .Sobrenome = "Raquel Siqueira", .Ano = AnoAcademico.Segundanista _
                                     }, New Aluno() With {.Nome = "Artur", .Sobrenome = "Geraldes", .Ano = AnoAcademico.Calouro _
                                     }, New Aluno() With {.Nome = "Paula", .Sobrenome = "Melado", .Ano = AnoAcademico.Calouro _
                                     }, New Aluno() With {.Nome = "Yan", .Sobrenome = "Li", .Ano = AnoAcademico.Junior _
                                     }, New Aluno() With {.Nome = "Yuri", .Sobrenome = "Siqueira Filho", .Ano = AnoAcademico.Junior _
                                     }, New Aluno() With {.Nome = "Laura", .Sobrenome = "Mendona", .Ano = AnoAcademico.Senior _
                                     }, New Aluno() With {.Nome = "Jose Carlos", .Sobrenome = "Macoratti", .Ano = AnoAcademico.Senior})

            context.SaveChanges()

            context.Cursos.AddOrUpdate(New Curso() With {.Titulo = "Qumica", .Creditos = 3 _
                                    }, New Curso() With {.Titulo = "Engenharia", .Creditos = 3 _
                                    }, New Curso() With {.Titulo = "Engenharia", .Creditos = 3 _
                                    }, New Curso() With {.Titulo = "Clculo", .Creditos = 4 _
                                    }, New Curso() With {.Titulo = "Trigonometria", .Creditos = 4 _
                                    }, New Curso() With {.Titulo = "Histria", .Creditos = 3 _
                                    }, New Curso() With {.Titulo = "Literatura", .Creditos = 4})

            context.SaveChanges()

            context.Matriculas.AddOrUpdate(New Matricula() With {.AlunoID = 1, .CursoID = 1, .Grau = 1 _
                                        }, New Matricula() With {.AlunoID = 1, .CursoID = 2, .Grau = 3 _
                                        }, New Matricula() With {.AlunoID = 1, .CursoID = 3, .Grau = 1 _
                                        }, New Matricula() With {.AlunoID = 2, .CursoID = 4, .Grau = 2 _
                                        }, New Matricula() With {.AlunoID = 2, .CursoID = 5, .Grau = 4 _
                                        }, New Matricula() With {.AlunoID = 2, .CursoID = 6, .Grau = 4 _
                                        }, New Matricula() With {.AlunoID = 3, .CursoID = 1}, _
                                           New Matricula() With {.AlunoID = 4, .CursoID = 1}, _
                                           New Matricula() With {.AlunoID = 4, .CursoID = 2, .Grau = 4 _
                                        }, New Matricula() With {.AlunoID = 5, .CursoID = 3, .Grau = 3 _
                                        }, New Matricula() With {.AlunoID = 6, .CursoID = 4}, _
                                           New Matricula() With {.AlunoID = 7, .CursoID = 5, .Grau = 2})
            context.SaveChanges()
        End Sub

    End Class

End Namespace
