﻿Imports System.Collections.Generic
Imports System.Data.Entity
Imports System.ComponentModel.DataAnnotations

Namespace Macoratti.Models

    Public Class EscolaContext
        Inherits DbContext

        Public Property Alunos() As DbSet(Of Aluno)
        Public Property Matriculas() As DbSet(Of Matricula)
        Public Property Cursos() As DbSet(Of Curso)
    End Class

    Public Class Aluno

        <Key, Display(Name:="ID")> _
        <ScaffoldColumn(False)> _
        Public Property AlunoID() As Integer

        <Required, StringLength(40), Display(Name:="Sobrenome")> _
        Public Property Sobrenome() As String

        <Required, StringLength(20), Display(Name:="Nome")> _
        Public Property Nome() As String

        <EnumDataType(GetType(AnoAcademico)), Display(Name:="Ano Acadêmico")> _
        Public Property Ano() As AnoAcademico

        Public Overridable Property Matriculas() As ICollection(Of Matricula)
    End Class

    Public Class Matricula
        <Key> _
        Public Property MatriculaID() As Integer
        Public Property CursoID() As Integer
        Public Property AlunoID() As Integer
        Public Property Grau() As System.Nullable(Of Decimal)
        Public Overridable Property Curso() As Curso
        Public Overridable Property Aluno() As Aluno
    End Class

    Public Class Curso
        <Key> _
        Public Property CursoID() As Integer
        Public Property Titulo() As String
        Public Property Creditos() As Integer
        Public Overridable Property Matriculas() As ICollection(Of Matricula)
    End Class

    Public Enum AnoAcademico
        Calouro
        Segundanista
        Junior
        Senior
    End Enum

End Namespace